//@ts-nocheck
import * as LZString from 'lz-string';
import { Notebook, NotebookActions } from '@jupyterlab/notebook';
import { IRouter } from '@jupyterlab/application';
import { ILauncher } from '@jupyterlab/launcher';
import { UUID } from '@lumino/coreutils';
import { INotebookTracker } from '@jupyterlab/notebook';
import { ToolbarButton } from '@jupyterlab/apputils';
console.log('notebook_to_url_ext is loaded!');
console.log('Notebook:', Notebook);
console.log('NotebookActions:', NotebookActions);
import { Clipboard } from '@jupyterlab/apputils';
console.log('notebook_ephem is loaded!');
let savedParams = null;
// Save the URL parameters on page load
function saveUrlParameters() {
    const urlParams = new URLSearchParams(window.location.hash.slice(1));
    savedParams = urlParams;
    console.log('Saved URL parameters:', savedParams.toString());
}
// Decompress the saved URL parameter and load notebook content
function decompressSavedContent() {
    if (savedParams) {
        const compressedContent = savedParams.get('notebook');
        if (compressedContent) {
            const decompressedContent = LZString.decompressFromEncodedURIComponent(compressedContent);
            return JSON.parse(decompressedContent);
        }
    }
    return null;
}
// Add a route to render the temporary notebook
function addTempNotebookRoute(app, filebrowserFactory, router) {
    const regiser = router.register({
        pattern: /.*\/lab\/temp-notebook/,
        command: 'notebook:open-temp'
    });
    console.log('registered', regiser, router);
    app.commands.addCommand('notebook:open-temp', {
        label: 'Open Temporary Notebook',
        execute: async (args) => {
            var _a, _b;
            console.log('executing create new');
            // Utility function to create a new notebook.
            const createNew = async (cwd, kernelId, kernelName) => {
                const model = await app.commands.execute('docmanager:new-untitled', {
                    path: cwd,
                    type: 'notebook'
                });
                console.log('created model', model);
                if (model !== undefined) {
                    const widget = (await app.commands.execute('docmanager:open', {
                        path: model.path,
                        factory: 'Notebook',
                        kernel: { id: kernelId, name: kernelName }
                    }));
                    widget.isUntitled = true;
                    const tempId = `temp-notebook-${UUID.uuid4()}`;
                    widget.context.rename(tempId + '.ipynb');
                    console.log('widget', widget);
                    return widget;
                }
            };
            const currentBrowser = (_a = filebrowserFactory === null || filebrowserFactory === void 0 ? void 0 : filebrowserFactory.tracker.currentWidget) !== null && _a !== void 0 ? _a : filebrowserFactory.defaultBrowser;
            const cwd = args['cwd'] || ((_b = currentBrowser === null || currentBrowser === void 0 ? void 0 : currentBrowser.model.path) !== null && _b !== void 0 ? _b : '');
            const kernelId = args['kernelId'] || '';
            const kernelName = args['kernelName'] || '';
            const model = await createNew(cwd, kernelId, kernelName);
            console.log('created model', model, cwd, 'kernel', kernelId, 'kernelName', kernelName);
            const content = decompressSavedContent();
            console.log('content', content);
        }
    });
    console.log(router.routed);
    router.routed.connect((_, args) => {
        console.log('Router routed:', args);
        if (args.path === '/temp-notebook') {
            app.commands.execute('notebook:open-temp', args);
            //   console.log('executing lab temp');
            //   // Utility function to create a new notebook.
            //   const createNew = async (
            //     cwd: string,
            //     kernelId: string,
            //     kernelName: string
            //   ) => {
            //     const model = await app.commands.execute('docmanager:new-untitled', {
            //       path: cwd,
            //       type: 'notebook'
            //     });
            //     console.log('created model', model);
            //     if (model !== undefined) {
            //       const widget = (await app.commands.execute('docmanager:open', {
            //         path: model.path,
            //         factory: 'Notebook',
            //         kernel: { id: kernelId, name: kernelName }
            //       })) as unknown as IDocumentWidget;
            //       widget.isUntitled = true;
            //       const tempId = `temp-notebook-${UUID.uuid4()}`;
            //       widget.context.rename(tempId + '.ipynb');
            //       console.log('widget', widget);
            //       return widget;
            //     }
            //   };
            //   const currentBrowser =
            //     filebrowserFactory?.tracker.currentWidget ??
            //     filebrowserFactory.defaultBrowser;
            //   const cwd = (args['cwd'] as string) || (currentBrowser?.model.path ?? '');
            //   const kernelId = (args['kernelId'] as string) || '';
            //   const kernelName = (args['kernelName'] as string) || '';
            //   const model = await createNew(cwd, kernelId, kernelName);
            //   console.log(
            //     'created model',
            //     model,
            //     cwd,
            //     'kernel',
            //     kernelId,
            //     'kernelName',
            //     kernelName
            //   );
            //   const content = decompressSavedContent();
            //   console.log('content', content);
        }
    });
}
// Add a custom launcher item
function addTempNotebookLauncher(app, launcher, router) {
    const command = 'launcher:create-temp-notebook';
    app.commands.addCommand(command, {
        label: 'Temp Notebook',
        caption: 'Create a new temporary notebook',
        execute: () => {
            console.log('Navigating to /lab/temp-notebook...');
            router.navigate('/temp-notebook', { hard: false, silent: false });
        }
    });
    launcher.add({
        command,
        category: 'Other'
    });
}
// Compress the notebook text and set as URL parameter
function compressNotebookContent(notebookPanel) {
    console.log('notebook panel', notebookPanel, notebookPanel.context.model.toJSON());
    const notebookContent = JSON.stringify(notebookPanel.context.model.toJSON());
    const compressedContent = LZString.compressToEncodedURIComponent(notebookContent);
    const newUrl = `${window.location.origin}${window.location.pathname}#notebook=${compressedContent}`;
    Clipboard.copyToSystem(newUrl);
    alert('URL copied to clipboard');
}
// Add "Save to URL" button to the notebook toolbar
function addSaveToUrlButton(app, notebookTracker) {
    const saveToUrlButton = new ToolbarButton({
        label: 'Save to URL',
        onClick: () => {
            const current = notebookTracker.currentWidget;
            if (current) {
                compressNotebookContent(current);
            }
        },
        tooltip: 'Save notebook content to URL and copy to clipboard'
    });
    notebookTracker.widgetAdded.connect((sender, panel) => {
        panel.toolbar.insertItem(10, 'saveToUrl', saveToUrlButton);
    });
}
import { IFileBrowserFactory } from '@jupyterlab/filebrowser';
const extension = {
    id: 'urlify-notebook',
    autoStart: true,
    requires: [IFileBrowserFactory, IRouter, ILauncher, INotebookTracker],
    activate: (app, filebrowserFactory, router, launcher, notebookTracker) => {
        addSaveToUrlButton(app, notebookTracker);
        // Save the URL parameters when the app is first loaded
        saveUrlParameters();
        // Add the route to handle /lab/temp-notebook path
        addTempNotebookRoute(app, filebrowserFactory, router);
        // Add a custom launcher item
        addTempNotebookLauncher(app, launcher, router);
    }
};
export default extension;
//# sourceMappingURL=working-index.js.map